#include <iostream>

using namespace std;

int main() {

  int n,m,u,v;
  cin>>n>>m;
  int a[m],b[m],t[m];
  for(int i=0;i<m;i++){
    cin>>a[i]>>b[i]>>t[i];
  }
  cin>>u>>v;
  int p;
  for(int j=u;j<=v;j+=p){
    int l=j;
    for(int z=0;z<m;z++){
      if(l==a[z]){
        p=a[z];
      }
    }
  }
  cout<< -1 <<endl;
  return 0;
}